杭电3342解题报告

http://acm.hdu.edu.cn/showproblem.php?pid=3342

Legal or Not

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1796 Accepted Submission(s): 790


Problem Description
ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not.

Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.


 

Input
The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0.
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.


 

Output
For each test case, print in one line the judgement of the messy relationship.
If it is legal, output "YES", otherwise "NO".


 

Sample Input
3 2 0 1 1 2 2 2 0 1 1 0 0 0


 

Sample Output
YES NO


 

Author
QiuQiu@NJFU


 

Source


 

Recommend
lcy
 
这题做的真是太好了。。一次AC虽然搜了解题报告(看了别人的思想),但是全部是自己写的,真的是无比的兴奋。就是简单的拓扑排序这题只要在杭电1285的基础上稍微改一下就可以AC了。加一个标识变量用来判断最好的结果是否还存在入度不为0的,如果存在,则输出NO,如果不存在则输出YES。(很简单吧)。不过我还很水的,接着努力吧!!(这题是在自己poj1094实在A不出来的时候找杭电上简单的拓扑排序做一下,目标还是poj1094).
#include<stdio.h>
#include<string.h>
int arc[501][501]; //邻接矩阵 
int n,m,top; 
int vis[501]; //标记访问过了没 
int index[501]; 
void init() 

      int i; 
      int a,b; 
      memset(vis,0,sizeof(vis));
      memset(index,0,sizeof(index));
      memset(arc,0,sizeof(arc));
      for(i=1;i<=m;i++)
     
              scanf("%d %d",&a,&b);
              if(!arc[a][b])// 因为有可能出现重边,所以前面初始为0
              {
                      arc[a][b]=1; 
                      index[b]++; //b的入度加1因为a是大于b的即a指向b从a到b(b是弧尾);
              }
   
     
}
void topsort()

      int i,j;
      while(top<n)
     
              for(i=0;i<n;i++)
                      if(index[i]==0&&!vis[i]) //每一次都可以找到入度为0的点 
                              break; //入度为0,并且i最小,一定可以排在最前面 
                      vis[i]=1;
                      //if(top) 
                        //    printf(" "); 
                      //printf("%d",i); 
                      top++; 
                      for(j=0;j<n;j++)
                      {
                              if(arc[i][j])
                                      index[j]--;//把以i为起点j为终点的入度减1 
                      }
      }
  int flag=0;
  for(j=0;j<n;j++)//就是多加了这里。
  {
    if(index[j])
    {
      flag=1;
    }
  }
  if(flag==1)printf("NO\n");
  else printf("YES\n");
}
int main()

      while(scanf("%d%d",&n,&m)!=EOF&&(n!=0||m!=0))
      {
              init(); 
              top=0;
              topsort();
            // printf("\n"); 
    }
      return 0; 
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值